#!/usr/bin/php
<?php
//define('PATH','/usr/local/esia/public_html');
define('NAME',"check_api_alert.php");
//include PATH.'/api/client/client.class.php";';
include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
include '/usr/local/esia/public_html/api/client/client.class.php';

$ERRORS= array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'MAINTENANCE'=>4);

function print_help()
{
	print_usage();
	echo "\t".NAME." : Vérifie l'état du satellite\n";
}

//Définition des paramètres d'exécution
$longopts  = array(
    "Host:",
	"Galaxy:",
	"File:",
    "help");
$options = getopt("H:G:F:h",$longopts); 

if(isset($options['h']) || isset($options['help']))
{
	print_help();
	exit($ERRORS['UNKNOWN']);
}

try
{
	$ip = null;
	$galaxy = null;
	$file = null;

	if((isset($options['H']) && !empty($options['H'])))
	{
		$ip = $options['H'];
	}
	if((isset($options['G']) && !empty($options['G'])))
	{
		$galaxy = $options['G'];
	}
	if((isset($options['F']) && !empty($options['F'])))
	{
		$file = $options['F'];
	}

	$content = @file_get_contents($file);
	if( $content === FALSE ) throw new Exception("Settings not found");
	$parsed = json_decode($content,true);

	$api = new ClientApi();
	$api->authentication($parsed['url'],$parsed['username'],$parsed['password'],$parsed['port']);	

	$ret = $api->get("alert");

	if( $ret == NULL ) $ret = array();

	$data=array();
	$valRet=array();
	foreach ($ret as $node) 
	{
		if(isset($node['type_error']) && !empty($node['type_error']))
		{
			$data[]=array('name'=>$node['name'],'type_error'=>$node['type_error']);
			if($node['type_error']=="critical")$valRet[]="critical";
			elseif($node['type_error']=="warning")$valRet[]="warning";
			elseif($node['type_error']=="unknown")$valRet[]="unknown";
			elseif($node['type_error']=="maintenance")$valRet[]="maintenance";
		}	 	
	}

	if(empty($data))
	{
		echo "OK - All yours nodes are good\n";
		$return=$ERRORS['OK'];
	}
	else
	{
		if(in_array('critical', $valRet)) 
		{
			$global_status = "CRITICAL";
			$return=$ERRORS['CRITICAL'];
		}
		elseif (in_array('warning', $valRet)) 
		{
			$global_status = "WARNING";
			$return=$ERRORS['WARNING'];
		}
		elseif (in_array('unknown', $valRet)) 
		{
			$global_status = "UNKNOWN";
			$return=$ERRORS['UNKNOWN'];
		}	
		elseif (in_array('maintenance', $valRet)) 
		{
			$global_status = "MAINTENANCE";
			$return=$ERRORS['MAINTENANCE'];
		}

		echo $global_status." : \n";
		foreach ($data as $d) 
		{
			echo $d['name']." is ".$d['type_error']."\n";
		}
	}	
}
catch(Exception $e)
{
	echo "Exception ".$e->getMessage()."\n";
	exit($ERRORS['UNKNOWN']);
}
exit($return);
?>
