#!/usr/bin/php
<?php
//define('PATH','/usr/local/esia/public_html');
define('NAME',"check_api_groupnode_state.php");
//include PATH.'/api/client/client.class.php";';
include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
include '/usr/local/esia/public_html/api/client/client.class.php';

$ERRORS= array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'MAINTENANCE'=>4);

function print_usage(){
	echo 'USAGE : '.NAME." -n <groupnode> -F file\n";
}

function print_help()
{
	print_usage();
	echo "\t".NAME." : Vérifie l'état du noeud\n";
	echo "\t\t[-n] 	| --i		id/nom du noeud\n";
	echo "\t\t[-h] 	| --help		affiche l'aide\n";
	echo "\t\t[-F] 	| --F		auth file\n";
}

//Définition des paramètres d'exécution
$longopts  = array(
	"Host:",
	"Galaxy:",
    "node:",
    "File:",
    "help");
$options = getopt("H:G:F:n:h",$longopts); 

if(isset($options['h']) || isset($options['help']))
{
	print_help();
	exit($ERRORS['UNKNOWN']);
}

try
{
	$node = null;
	$ip = null;
	$galaxy = null;
	$file = null;

	if((isset($options['n']) && !empty($options['n'])))
	{
		$node = $options['n'];
	}
	if((isset($options['H']) && !empty($options['H'])))
	{
		$ip = $options['H'];
	}
	if((isset($options['G']) && !empty($options['G'])))
	{
		$galaxy = $options['G'];
	}
	if((isset($options['F']) && !empty($options['F'])))
	{
		$file = $options['F'];
	}

	$content = @file_get_contents($file);
	if( $content === FALSE ) throw new Exception("Settings not found");
	$parsed = json_decode($content,true);

	$api = new ClientApi();
	$api->authentication($parsed['url'],$parsed['username'],$parsed['password'],$parsed['port']);	
	$ret = $api->get("state/node/".$node."");

	$output = $ret['OK'] . " Ok | ".$ret['warning'] . " Warning | ".$ret['critical'] . " Critical | ".$ret['unknown']." Unknown";

	$global_status = "OK";
	$return=$ERRORS['OK'];
	if($ret['critical']>0) 
	{
		$global_status = "CRITICAL";
		$return=$ERRORS['CRITICAL'];
	}
	else if ($ret['warning']>0)
	{
		$global_status = "WARNING";
		$return=$ERRORS['WARNING'];
	}
	else if ($ret['unknown']>0)
	{
		$global_status = "UNKNOWN";
		$return=$ERRORS['UNKNOWN'];
	}
	else if ($ret['maintenance']>0)
	{
		$global_status = "MAINTENANCE";
		$return=$ERRORS['MAINTENANCE'];
	}

	echo "Node ".$node." is $global_status => $output\n";
}
catch(Exception $e)
{
	echo "Exception ".$e->getMessage()."\n";
	exit($ERRORS['UNKNOWN']);
}
exit($return);
?>
