#!/usr/bin/php
<?php

$PATH_LICENCE_PRIV_KEY='/etc/esia/licence/id_rsa';
$PATH_LICENCE_PUB_KEY='/etc/esia/licence/id_rsa.pub';
$PATH_LICENCE_CHECK="/usr/local/esia/licence/validate_licence";
$RSS_MERCURY_CATEGORY = 'Mercury'; // Category on the Mercury

$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$ARRAY_GROUP= array();

include_once '/usr/local/esia/public_html/esia.conf.php';
include_once '/usr/local/esia/public_html/Model_esia.php';
include_once "/usr/local/esia/public_html/api/client/client.class.php";

// Get all RSS LOCAL channels tag as Mercury (category)
function getMercuryRSSChannels($dbconnection, $mercuryCat='Mercury')
{
    // Get RSS mercury chans IDs
    $mercuryChans = Model_esia::getRSSChannelByCategory($dbconnection, $mercuryCat);
    if(!empty($mercuryChans))
    {
        // From those IDs get RSS chans data only for LOCAL chans
        $mercuryChans = Model_esia::getRSSChannel($dbconnection, $mercuryChans, 'LOCAL');
    }

    return $mercuryChans;
}

// Subscribe a Galaxy to his parent Mercury RSS channel
function postRSSChannels($client, $mercuryChans=array(), $rssPostData=array(), $mercuryCat='Mercury')
{
	// Fetch RSS channels tagged as Mercury from the remote galaxy
	$galaxyChans = @$client->get('rss/channel', array(
		'type' => 'REMOTE',
		'categories' => $mercuryCat,
	));

	// Save all url to check if the channels from the mercury server are present in the galaxy
	$galaxyChansUrl = array();
	if(!empty($galaxyChans))
	{
		// If the client return an empty array the value is NULL (not an empty array)
		foreach($galaxyChans as $chan)
		{
			$galaxyChansUrl[] = trim($chan['url']);
		}
	}

	foreach($mercuryChans as $chan)
	{
		// Check if enabled
		if(!empty($chan['enable']))
		{
			$data = $rssPostData;
			$data['url'] .= urlencode($chan['name']);

			if(in_array($data['url'], $galaxyChansUrl))
			{
				// The mercury channel already exist on the remote galaxy. Got to the next channel
                echo "RSS channel already exists on galaxy: " . $chan['name'] . "\n";
				continue;
			}

			$data['name'] = $chan['name'];
			$data['description'] = $chan['description'];
			$data['lang'] = $chan['lang'];
            $data['categories'] = $chan['category'];
            
			// Add the Mercury channel into the galaxy client
			$client->post('rss/channel', $data);

            echo "New RSS channel added: " . $data['name'] . "\n";
		}
	}
}

//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
$licence = Model_esia::getLicenceInformation($dbconnection);
//print_r($licence);
$now = new DateTime();
$time = $now->getTimestamp();

if( $licence['type'] == 'Mercury' &&  $licence['expire'] > $time)
{
    exec($PATH_LICENCE_CHECK,$output,$ret);
    if($ret!=0)
    {
        echo "BAD LICENCE\n";
        exit(1);
    }
    $sql = "SELECT conso_device_id,conso_node, extract(EPOCH FROM ( NOW() - conso_last_update))::int as last_update FROM esia_consumption;";
    $query = $dbconnection->prepare($sql);
    $query->execute();
    $allconso=array();
    $global_maxnode=$licence['node'];
    $total=0;
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $allconso[$row->conso_device_id]=array('node'=>$row->conso_node,'last_update'=>$row->last_update);
        $total=$total + $row->conso_node;
    }
    $global_maxnode = $global_maxnode - $total;
    $query_insert = "INSERT INTO esia_consumption(conso_node,conso_device_id,conso_last_update) VALUES (?, ?,NOW());";
    $query_update = "UPDATE esia_consumption SET conso_node=?,conso_last_update=NOW() WHERE conso_device_id=?;";
    $query_select = "SELECT conso_max_node FROM esia_consumption WHERE conso_device_id=?;";
//	echo "ici";
//	print_r($allconso);
    $query_insert = $dbconnection->prepare($query_insert);
    $query_update = $dbconnection->prepare($query_update);
    $query_select = $dbconnection->prepare($query_select);
    $sql =" SELECT device_id,device_config_type_name,adv_param,adv_authfile_crypt,adv_plugin_keyword_value
                FROM esia_device 
                JOIN esia_device_advance_config ON device_id = adv_device_id
                JOIN esia_device_advance_config_type ON device_config_type_id = adv_config_type_id
                WHERE device_config_type_name='API'";
    $query = $dbconnection->prepare($sql);
    $query->execute();

    // If there is galaxy node configured
    $mercuryChans = array();
    $rssPostData = array();
    if($query->rowCount() > 0)
    {
        // Check for RSS channel tagged as Mercury to push it to the galaxy
        try
        {
            $mercuryChans = getMercuryRSSChannels($dbconnection, $RSS_MERCURY_CATEGORY);
            // Prepare default data request for RSS api POST channel
            $serverFQDN = Model_esia::getConfiguration($dbconnection, 'ESIA_URL');
            $serverFQDN = $serverFQDN['ESIA_URL']['value'];
            $rssPostData = array(
                'action' => 'add',
                'name' => '',
                'description' => '',
                'url' => rtrim($serverFQDN, '/') . '/rss.php?flow=',
                'lang' => '',
                'enable' => 1,
                'group' => 'RSS_GROUP_ALL',
                'categories' => $RSS_MERCURY_CATEGORY,
            );
        }
        catch(EsiaDbException | Exception $e)
        {
            echo "FAILED to retreive Mercury RSS channels: " . $e->getMessage() . "\n";
        }
    }
    
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $node = Model_esia::InstanceNode($dbconnection,$row->device_id);
        $file = fopen($row->adv_plugin_keyword_value, "r");
        if(!$file)
        {
	    continue;
          //  throw new Exception("can't open file:".$row->adv_plugin_keyword_value);
        }
        $buffer="";
        while (($line = fgets($file)) !== false) 
        {
            $buffer.=$line;
        }
        fclose($file);
        $auth = json_decode($buffer,true);
        $output="";
        $client = NULL;
        try
        {
                echo "Connect to ".str_pad($node->getName(),40)." : ";
                $client = new ClientApi();
                $client->authentication($auth['url'],$auth['username'],$auth['password'],$auth['port']);
                $state = $client->get('state');
                if(array_key_exists($node->getId(),$allconso))
                {
                    $query_update->execute(array($state['total_node'],$node->getId()));
                    $query_select->execute(array($node->getId())); 
                    $fixenode=$query_select->fetch(PDO::FETCH_OBJ);
                    $fixenode = $fixenode->conso_max_node;
                    $now = new DateTime();
                    $time = $now->getTimestamp();
                    $lic = $client->get('license');
                    if(empty($lic['expire']) || $fixenode==-1  || empty($fixenode))
				    {
		            	$query_insert->execute(array($state['total_node'],$node->getId()));
		                exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$global_maxnode ,$output,$ret);
		                $licence = "";
		                foreach($output as $line)
		                {
		                	$licence .= $line."\n";
		               	}
		                $client->post('license',array('license'=>$licence));
				   } 
				   else
				   {
                        $expire = $lic['expire'] - $time;
                        $flag_update = false;
                        if( $lic['max_nodes'] != $fixenode)
                        {
                            $flag_update=true;
                        }
                        if($expire < 2592000)
                        {
                            $flag_update=true;
                        }
                        if($flag_update == true)
                        {
                            echo " Renew licence fixed $fixenode";
                            exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$fixenode ,$output,$ret);
                            $licence = "";
                            foreach($output as $line)
                            {
                                $licence .= $line."\n";
                            }
                            $client->post('license',array('license'=>$licence));
                        }
                    }
                }
                else
                {
	            	echo " Renew Licence ";
                    $query_insert->execute(array($state['total_node'],$node->getId()));
                    exec($PATH_LICENCE_CHECK." -p ".$PATH_LICENCE_PUB_KEY." -k ".$PATH_LICENCE_PRIV_KEY.' -g Mercury-client -n '.$global_maxnode ,$output,$ret);
                    $licence = "";
                    foreach($output as $line)
                    {
                        $licence .= $line."\n";
                    }
                    $client->post('license',array('license'=>$licence));
                }
                echo "SUCCESS\n\n";

                // RSS Channels
                if(!empty($mercuryChans))
                {
                    echo "Subscribe Mercury RSS channels\n";
                    postRSSChannels($client, $mercuryChans, $rssPostData, $RSS_MERCURY_CATEGORY);
                    echo "RSS subscription successful\n\n";
                }
        }
        catch(Exception $e)
        {
            echo" FAILED ".$e->getMessage()."\n";
        }

        // Dont forget to logout if the client has been correctly instanciated
        if(@get_class($client) == 'ClientApi')
        {
            $client->logout();
        }
    }
}
else
{
	echo" ERR Bad licence type or licence is expired\n";
}
exit(0);
?>
