function generateDonuts(dataVide,data,bind,legend,time,color='esia_state',unit=undefined,pwidth='auto',pheight=undefined,from='other') {
	if( typeof color !== 'object'){
		if(typeof color === 'string' && color == 'esia_state'){
			color = ['#83bc00', '#ffcb1f', '#da002e', '#575759', '#3263c5'];
		}
	}
	else if(color === null){
		color = undefined;
	}
	
	var position = 'bottom';
	if( typeof legend === 'string' ){
		position = legend;
		legend = true;
	}
	
	var arr = {label: {show: true}};
	if(pwidth !='auto')
	{
		arr = {	width:pwidth,label: {show: false}};
	}
	
	var chart = bb.generate({
	    bindto: '#'+bind,
	    data: {
    		columns: dataVide,
			type:'donut',
			empty: { label: { text: "No Data Available." }, },
		},
		color: {
			  pattern: color
			},
	    transition: {
		  duration: 500
		},
		legend: {
		  show: legend,
		  position : position
		},
		donut:  {
		    label: {show: false}
		    },
		size: {
		  height: pheight
		}
	});
	setTimeout(function () {
	    chart.load({
	    	columns: data,
	    });
	}, 100);
	return chart;
}

function CreationGaugeHtml(id,val,state)
{			
	var color_state = {"ok":"#83bc00","warning":"#ffcb1f","critical":"#da002e","unknown":"#575759","maintenance":"#3263c5","pending":"#3263c5"};
	
	var chart = bb.generate({
			bindto: "#"+id,
			data: {
				columns: [["", val]],
				type:"gauge"
			},
			color: {
				pattern: [color_state[state]]
			},
			size: {
				height: 110,
				width:220,
			},
			gauge: {
				label:{
					format: function(value, ratio){
						return value;
					},
				},
				min: 0,
				max: 100,
				units: "%" 
			},
			tooltip: {
				format: {
					value: function (value, ratio, id) {
						var format = d3.format(',');
							return format(value);
						}
				}
			}
	});
}